#ifndef TEXTUREBLUR_H
#define TEXTUREBLUR_H

#include <glew/glew.h>

class FrameBuffer;
class Shader;
class ShaderSource;
class Texture;

class TextureBlur
{
    FrameBuffer* fbos;
    FrameBuffer* m_input;
    int m_downsampling;
    Shader* horizontal;
    Shader* vertical;
    enum UniformLocation {
        H_SAMPLER,
        H_WIDTH,
        H_HEIGHT,
        V_SAMPLER,
        V_WIDTH,
        V_HEIGHT
    };
    GLuint uniformLocations[6];

public:
    TextureBlur(FrameBuffer* input, int downsampling = 3, int textureId = 0);
    ~TextureBlur();
    void setSource(ShaderSource* source);
    void blur();
    Texture* getTexture(int downsamplingLevel);
};

#endif // TEXTUREBLUR_H
